/* <stream.h> - emiprically-discovered archaic (cfront) iostream compatibility
 * - content determined by trial-and-error compilations of users of <stream.h>
 * - also based on comments in (ancient) USL man pages about <stream.h>
 * - declarations of like data items to ones used have been added for
 *   completeness; n.b. atend==ios::ate, etc.
 */

#ifndef _STREAM_ARCHAIC_H
#define _STREAM_ARCHAIC_H

 #if ! ( defined(__ECC) || defined(__INTEL_COMPILER) )
// use gcc's <stream.h>
  #include_next <stream.h>

 #else /* is Intel ecc/ecpc compiler */
  #include <iostream.h>
  #include <iomanip.h>
// #include <stdiostream.h>
  #include <fstream.h>	/* for filebuf */

// warning: not re-entrant, not thread-safe (c.b. if thread-local storage?)
// formatted information placed in global buffers
#define _FORM_MAX_WIDTH	512

extern char* oct(long, int = 0);
extern char* dec(long, int = 0);
extern char* hex(long, int = 0);
extern char* chr(int, int = 0);	/* chr(0) is the empty string "" */
extern char* str(const char*, int = 0);
extern char* form(const char*, ...);
	// warning: generated string must be known to not exceed _FORM_MAX_WIDTH
	// overindexing this length will result in memory corruption

extern istream& WS(istream&);
extern void eatwhite(istream&);

static const int input = ios::in;
static const int output = ios::out;
static const int append = ios::app;
static const int atend = ios::ate;
static const int _good = ios::goodbit;
static const int _bad = ios::badbit;
static const int _fail = ios::failbit;
static const int _eof = ios::eofbit;

typedef ios::io_state state_value;
 #endif /* is Intel ecc/ecpc compiler */
#endif /* _STREAM_ARCHAIC_H */

/*
 * Copyright (c) 1992-2001 by P.J. Plauger.  ALL RIGHTS RESERVED.
 * Consult your license regarding permissions and restrictions.
V3.10:1161 */
