/* static char cvs_id[] = "$Id:"; */

#ifndef _ASM_IA64_TYPES_H
#define _ASM_IA64_TYPES_H

/*
 * This file is never included by application software unless
 * explicitly requested (e.g., via linux/types.h) in which case the
 * application is Linux specific so (user-) name space pollution is
 * not a major issue.  However, for interoperability, libraries still
 * need to be careful to avoid a name clashes.
 *
 * Copyright (C) 1998-2000 Hewlett-Packard Co
 * Copyright (C) 1998-2000 David Mosberger-Tang <davidm@hpl.hp.com>
 */

#ifdef __ASSEMBLY__
# define __IA64_UL(x)		x
# define __IA64_UL_CONST(x)	x
#else
# define __IA64_UL(x)		((unsigned long)x)
# define __IA64_UL_CONST(x)	x##UL
#endif

#ifndef __ASSEMBLY__

typedef unsigned int umode_t;

/*
 * __xx is ok: it doesn't pollute the POSIX namespace. Use these in the
 * header files exported to user space
 */
#ifdef __ECC                          /*MERGE 12/5/00 UDAY*/
typedef signed char __s8;             /*MERGE 12/5/00 UDAY*/
#else                                 /*MERGE 12/5/00 UDAY*/
typedef __signed__ char __s8;
#endif                                /*MERGE 12/5/00 UDAY*/
typedef unsigned char __u8;

#ifdef __ECC                           /*MERGE 12/5/00 UDAY*/
typedef signed short __s16;            /*MERGE 12/5/00 UDAY*/
#else                                  /*MERGE 12/5/00 UDAY*/
typedef __signed__ short __s16;
#endif                                 /*MERGE 12/5/00 UDAY*/ 

typedef unsigned short __u16;

#ifdef __ECC                           /*MERGE 12/5/00 UDAY*/
typedef signed int __s32;              /*MERGE 12/5/00 UDAY*/
#else                                  /*MERGE 12/5/00 UDAY*/
typedef __signed__ int __s32;
#endif                                 /*MERGE 12/5/00 UDAY*/
typedef unsigned int __u32;

/*                                                            
 * There are 32-bit compilers for the ia-64 out there..       
 */                                                           
# if ((~0UL) == 0xffffffff)                                   /*MERGE 12/5/00 UDAY*/
#  if defined(__GNUC__) && !defined(__STRICT_ANSI__)          /*MERGE 12/5/00 UDAY*/

typedef __signed__ long __s64;
typedef unsigned long __u64;
#endif                                                        /*MERGE 12/5/00 UDAY*/
#else                                                         /*MERGE 12/5/00 UDAY*/
#ifdef __ECC                                                  /*MERGE 12/5/00 UDAY*/
typedef signed long __s64;                                    /*MERGE 12/5/00 UDAY*/
#else                                                         /*MERGE 12/5/00 UDAY*/
typedef __signed__ long __s64;                                /*MERGE 12/5/00 UDAY*/
#endif                                                        /*MERGE 12/5/00 UDAY*/
typedef unsigned long __u64;                                  /*MERGE 12/5/00 UDAY*/
# endif                                                       /*MERGE 12/5/00 UDAY*/

/*
 * These aren't exported outside the kernel to avoid name space clashes
 */
# ifdef __KERNEL__

typedef __s8 s8;
typedef __u8 u8;

typedef __s16 s16;
typedef __u16 u16;

typedef __s32 s32;
typedef __u32 u32;

typedef __s64 s64;
typedef __u64 u64;

#  ifdef __LP64__                         /*MERGE 12/5/00 UDAY*/     
typedef signed long s64;                  /*MERGE 12/5/00 UDAY*/
typedef unsigned long u64;                /*MERGE 12/5/00 UDAY*/
#  else                                   /*MERGE 12/5/00 UDAY*/
typedef signed long long s64;             /*MERGE 12/5/00 UDAY*/
typedef unsigned long long u64;           /*MERGE 12/5/00 UDAY*/
#  endif                                  /*MERGE 12/5/00 UDAY*/

#define BITS_PER_LONG 64

/* DMA addresses are 64-bits wide, in general.  */

typedef u64 dma_addr_t;

# endif /* __KERNEL__ */
#endif /* !__ASSEMBLY__ */

#endif /* _ASM_IA64_TYPES_H */
